function S=weightedSupdate(A,S,X,W)

%update S for the euclidean distance cost

if 0
  divisor=A'*((W.^2).*(A*S));
  valid=find(divisor);

  S=S.*(A'*(X.*(W.^2)));
  S(valid)=S(valid)./divisor(valid);
  
else

  warning off MATLAB:divideByZero
  S=S.*(A'*(X.*(W.^2)))./(A'*((W.^2).*(A*S)));
  warning on MATLAB:divideByZero

  S(isnan(S))=0;

end
%set values which are almost zero to zero
S(S<1e-16)=0;



