function [dS,rec_e]=klgrad(A,S,W,threshold,alfa,mod_X)

%gradient of the divergence with respect to A

V=A*S+threshold;

notvalid=(mod_X==0)|(V==0);
mod_X(notvalid)=1;
V(notvalid)=1;


if alfa~=1
  dS=A'*(W.*(V.^(alfa-1)-mod_X./V));
else
  dS=A'*(W.*(ones(size(V))-mod_X./V));
end

D=mod_X.*log(mod_X./V)-mod_X+V;
rec_e=sum(D(:));
