function S=powklupdate(X,A,S,alfa,W,threshold,reweight,mod_X)

%update source matrix S in the generalized divergence model

%S=S.*(A'*(X./(A*S)))./repmat(sum(A,1)',1,size(S,2));

V=A*S+threshold;

notvalid=(V==0);
V(notvalid)=1;
W(notvalid)=1;


if exist('mod_X','var')&&~isempty(mod_X)
  Y=mod_X./V;
else
  Y=((X+threshold).^alfa)./V;
end
Y=Y.*W;

if alfa~=1
  V=V.^(alfa-1);
  V=V.*W;
else
  V=W;
end


%S=S.*(A'*Y)./(A'*(V.^(alfa-1)));
%S=S.*(A'*Y)./(A'*VV);
multip=A'*Y;
divis=A'*V;
notvalid=(divis==0);
divis(notvalid)=1;
S=S.*(multip./divis);
S(notvalid)=0;

%S(isnan(S))=0;

%set values which are almost zero to zero
S(S<1e-16)=0;


